<?php
function hex2rgb($hex){
$temp = substr($hex,1);
if (strlen($temp) != 6){
echo "hex2rgb error: ".$hex;
exit;
}
$tempA = Array();
$tempA['r'] = hexdec(substr($temp,0,2));
$tempA['g'] = hexdec(substr($temp,2,2));
$tempA['b'] = hexdec(substr($temp,4,2));
return $tempA;
}
function checkfont($font){
	$fonts = scandr("./fonts",true);	
	if ($font == "Default"){return true;}
	foreach ($fonts as $f)
	{
		if ($f==$font){
			return true;
		}
	}
	return false;
}
function checkbanindex()
{
	$realip = $_SERVER['REMOTE_ADDR'];
	$myFiles = "txt/banlist.txt"; //Check if user is on ban list!
	if (filesize($myFiles) != 0){
		$fhs = fopen($myFiles, 'r');
		$thedatas = fread($fhs, filesize($myFiles));
		fclose($fhs);

		$values = explode("\r\n",$thedatas);

		$p = count($values);
		for ($q = 0; $q < $p ; $q++) {
			$tempa = explode("-",$values[$q]);
			if ($tempa[0] == $realip) {

				$im = imagecreatefromfile(getbackimage());
				$background = imagecolorallocate($im, 0, 0, 0);
				$wc = ImageColorAllocate ($im, 255, 0, 0); 
				$reason = $tempa[1];
				ImageString($im, 3, 0, 0, "BANNED! - $reason", $wc); 
				Imagepng($im); 
				ImageDestroy ($im); 
				exit;
			}
		}
	}
}
function getsmilies(){
	$smilies = array();
	$smiliesurl = array();
	$files = scandr("smilies/");
	$on = 0;
	foreach($files as $file)
	{
		$by = substr($file,strlen($file) - 3,3);
		$bz = substr($file,0,strlen($file) - 4);
		if ($by == "jpg" or $by == "png" or $by == "gif")
		{
			$smilies[$on] = $bz;
			$smiliesurl[$on] = "smilies/".$file;
			$on++;
		}
	}
	$ret = array(0=>$smilies,1=>$smiliesurl);
	return $ret;
}
function GetVars($page = 0,$preview = false,$info = null){
	$signed = "signs/$page.txt";
	$ret = array();
	$temp = getsmilies();
	$smilies = $temp[0];
	$smiliesurl = $temp[1];
	$thedata = "";
	if (file_exists($signed)==true){
		if (filesize($signed) == 0 && $preview == false){
			blankimage(getbackimage(false),$page);
			exit;
		}
		if (filesize($signed) == 0 && $preview == true){
			
		}else{
			$fh = fopen($signed, 'r');
			$thedata = fread($fh, filesize($signed));
			fclose($fh);
		}
		if ($preview==true){
			if (filesize($signed) != 0){
				$info = "\r\n" . $info;
			}
			$thedata = $thedata . $info;
		}
	}else{
	 	if ($preview==true){
			$thedata = $info;
		}
	 }
	$value = explode("\r\n", $thedata );
	$l = count($value);
	$ret['size'] = $l;
	$ret['adds'] = array();
	$ret['addx'] = array();
	$ret['addy'] = array();
	$ret['str'] = array();
	$ret['cols'] = array();
	$ret['cords'] = array();
	$ret['font'] = array();
	$on2 = 0;
	for ($i = 0; $i < $l ; $i++) {
		$pieces = explode("-", $value[$i] );
		$str = " ".$pieces[0];
		$cords = explode(",",$pieces[1]);
		$size = 7;
		if ($pieces[3] != "Default" && $pieces[3] != ""){
			$size = imagefontwidth(imageloadfont("fonts/".$pieces[3]));
		}
		foreach($smilies as $smil)
		{
			$on = 0;
			$temp = 12;
			while ($temp !=0)
			{
				$temp = strpos($str,$smil,$on);
				$on = $temp;
				if ($temp != 0)
				{
					$str = substr_replace($str,'  ',$temp,strlen($smil)); //2 or 3 spaces
					$ret['adds'][$on2] = $smiliesurl[array_search($smil, $smilies)];
					$ret['addx'][$on2] = (($temp-1) * $size) + $cords[0];
					$ret['addy'][$on2] = $cords[1];
					$on2++;
				}
			}
		}
		$str = substr($str,1);
		$ret['str'][$i] = $str;
		$ret['cols'][$i] = $pieces[2];
		$ret['cords'][$i] = $pieces[1];
		$ret['font'][$i] = $pieces[3];
		
	}
	return $ret;
}
function imagecreatefromfile($file)
{
$ext = substr($file,-3);
if ($ext == 'gif'){
$im = imagecreatefromgif( $file );
}elseif ($ext == 'jpg'){
$im = imagecreatefromjpeg( $file );
}elseif ($ext == 'png'){
$im = imagecreatefrompng( $file );
}
return $im;
}
function scandr($dir,$inc = false)
{
	$dh  = opendir($dir);
	while (false !== ($filename = readdir($dh))) {
	    if ($inc==true){
			if ($filename!="." && $filename!=".."){
				$files[] = $filename;
			}
		}else{
			$files[] = $filename;
		}
	}
	return $files;
}
function noext($file)
{
	return substr($file,0,-4);
}
function getbackimage($create = false)
{
	$files = scandr("./imgs");
	$loc = "non";
	foreach($files as $file)
	{
		$ja = explode(".",$file);
		if ($ja[0] == "back")
		{
			$T = $ja[1];
			if ($T == "jpg" or $T == "png" or $T == "gif")
			{
				$loc = $file;
			}
		}
	}
	
	if ($loc == "non")
	{
		$im = imagecreate(91,15);
		$background = imagecolorallocate($im, 0, 0, 0);
		$wc = ImageColorAllocate ($im, 255, 0, 0); 
		ImageString($im, 3, 0, 0, "No Back Image", $wc); 
		Imagepng($im); 
		ImageDestroy ($im); 
		exit;
	}
	if ($create == true){
	 	$im = imagecreatefromfile("imgs/".$loc);
		Imagepng($im); 
		ImageDestroy ($im); 
		exit;
	}
	return "imgs/".$loc;
}
function isimage($img) // check if it is a supported image type.
{
	if (strlen($img) < 4){
		return false;
	}
	$T = substr($img,-3);
	if ($T != "jpg" and $T != "png" and $T != "gif"){
		return false;
	}
	return true;
}
function deletebackimage()
{
	$files = scandr("./imgs");
	$loc = "non";
	foreach($files as $file)
	{
		$ja = explode(".",$file);
		if ($ja[0] == "back")
		{
			$T = $ja[1];
			if ($T == "jpg" or $T == "png" or $T == "gif")
			{
				$loc = $file;
			}
		}
	}
	if ($loc != 'non')
	{
		unlink($loc);
		return true;
	}else{return false;}
}
function blankimage($back,$page = null)
{
	$im = imagecreatefromfile($back);
	if ($page!=null){
		$bl = ImageColorAllocate ($im,0,0,0);
		imagestring($im,3,6,imagesy($im)-19,"Page ".$page,$bl);
	}
	Imagepng($im); 
	ImageDestroy ($im); 
}
function signmestatus()
{
	$fstatus = "txt/status.txt";
	$fhstatus = fopen($fstatus, 'r');
	$status = fread($fhstatus, filesize($fstatus));
	fclose($fhstatus);
	if ($status != "up"){
	return false;
	exit;
	}
	return true;
}

function checkban($ip,$banlist)
{
	$myFiles = $banlist;
	if (filesize($myFiles) != 0){
		$fhs = fopen($myFiles, 'r');
		$thedatas = fread($fhs, filesize($myFiles));
		fclose($fhs);

		$values = explode("\r\n",$thedatas);

		$p = count($values);
		for ($q = 0; $q < $p ; $q++) {
		$tempa = explode("-",$values[$q]);
		if ($tempa[0] == $ip) {
		return true;
		}
		}
	}
	return false;
}
function Signed($ip,$signings)
{
	$myFiles = $signings;
	if (filesize($myFiles) != 0){
		$fhs = fopen($myFiles, 'r');
		$thedatas = fread($fhs, filesize($myFiles));
		fclose($fhs);

		$values = explode("\r\n",$thedatas);

		$p = count($values);
		for ($q = 0; $q < $p ; $q++){
			if ($values[$q] != ''){
				$tempa = explode("-",$values[$q]);
				if ($tempa[5] == $ip){
					if (time()<($tempa[6] + 86400)){
						return true;
					}
				}
			}
		}
	}
	return false;
}
function isNCvalid($name,$cords)
{
	if ($name == "Noob" or $cords == "0,0")
	{
		return false;
	}
	return true;
}
function AddBan($ip,$reason)
{
		$myFile = 'txt/banlist.txt';
		$ban = "$ip-$reason";
		if (filesize($myFile) != 0){$ban = "\r\n$ban";}
		
		$fhs = fopen($myFile, 'a');
		$thedatas = fwrite($fhs,$ban);
		fclose($fhs);
}
function CheckVulgText($text,$ip)
{
	$text = strtolower($text);
	$h = fopen('txt/filter.txt','r');
	$words = fread($h,filesize('txt/filter.txt'));
	fclose($h);
	$vulgs = explode(",",$words);
	foreach($vulgs as $vulg)
	{
		if (strstr($text,$vulg)==true)
		{
			AddBan($ip,'Grow Up.');
			echo "Grow Up.";
			exit;
		}
	}
}
function isip($ip)
{
	$s = explode('.',$ip);
	if (count($s) != 4){
		return false;
	}
	foreach($s as $sip){
		if ($sip < 0 or $sip > 255){
			return false;
		}
	}
	return true;
}
function PageReload()
{
	echo "<script language='JavaScript'>window.location.href=window.location.href</script>";
}
function cleanstring($str)
{
	$cleanme = array("'","\r\n", "\r", "\n",";");
	$str = str_replace($cleanme,'',$str);
	return $str;
}
?>